
Type TApp
	
	Global UPS
	Global Iterator
	Global CurTime
	Global PauseStart=0
	Global ASpeed:Float=1.0
	Global Framerate:Int = 60
	Global DesiredLoopTime#=1000.0/60.0
	Global LastUpdateTime=0
	Global LastUPSTime
	
	Function Close()
		END
	End Function
	
	Function Update()
		Local time
		Local elapsed
		
		If PauseStart Return
		
		DesiredLoopTime=1000.0/framerate
	
		time=MilliSecs()
	
		If LastUpdateTime=0
			ASpeed#=1.0
			LastUpdateTime=time
			CurTime=time
			LastUPSTime=time
		Else
			elapsed=time-LastUpdateTime
			If Not elapsed
				elapsed=1
				Delay 1
				time:+1
			EndIf
			ASpeed=Float(elapsed)/Float(DesiredLoopTime)
			CurTime=time
			LastUpdateTime=time
		EndIf
		
		Iterator:+1
		If CurTime-LastUPSTime>=1000
			UPS=Float(Iterator)/(Float(CurTime-LastUPSTime)/1000.0)
			LastUPSTime=CurTime
			Iterator=0
		EndIf
		
	EndFunction
	
	Function Time()
		Return CurTime
	EndFunction
	
	Function Speed#()
		Return ASpeed
	EndFunction
	
	Function FPS:Int()
		Return UPS
	EndFunction
	
	Function Pause()
		If PauseStart Return
		PauseStart=MilliSecs()
	EndFunction

	Function Resume()
		If Not PauseStart Return
		If LastUpdateTime
			Local elapsed=MilliSecs()-PauseStart
			LastUpdateTime:+elapsed
		EndIf
		PauseStart=0
	EndFunction
	
End Type
