
Type TUIPanel
	
	Field Parent:TUIWindow, ChildList:TList
	Field X:Int, Y:Int, W:Int, H:Int, LX:Int, LY:Int
		
	Function Create:TUIPanel( Parent:TUIWindow, X:Int, Y:Int, W:Int, H:Int )
		
		Local A:TUIPanel = New TUIPanel
			A.Parent = Parent
			A.LX = X
			A.LY = Y
			A.W = W
			A.H = H
			A.ChildList = CreateList()
			
			Return( A )
			
	End Function
	
	Method Update()
		
		Local O:Object
		
		X =TUIWindow(Parent).X + TUIWindow(Parent).CX + LX
		Y = TUIWindow(Parent).Y + TUIWindow(Parent).CY + LY
		
		For O = EachIn ChildList
			If TUIButton( O )
				TUIButton( O ).Update()
			EndIf
			If TUIProgBar( O )
				TUIProgBar( O ).Update()
			EndIf
			If TUITextInput( O )
				TUITextInput( O ).Update()
			EndIf
		Next
		
	End Method
	
End Type
